module Kounta
  class Staff < Kounta::Resource
    property :company_id
    property :first_name
    property :last_name
    property :email
    property :primary_email_address
    property :email_addresses
    property :phone
    property :mobile
    property :fax
    property :shipping_address
    property :postal_address
    property :addresses
    property :sites
    property :permissions
    property :image

    def name
      "#{first_name} #{last_name}"
    end

    has_many(:shifts_since, Kounta::Shift, { company_id: :company_id },
             proc { |klass, date| { companies: klass.company_id, staff: klass.id, shifts: nil, since: Kounta.format_date(date) } })

    def resource_path
      { companies: company_id, staff: id }
    end
  end
end
